from collections.abc import MutableSequence
from typing import Any

import proto
from google.rpc.status_pb2 import Status

from google.ads.googleads.v14.enums.types.response_content_type import (
    ResponseContentTypeEnum,
)
from google.ads.googleads.v14.resources.types.ad_group_asset_set import AdGroupAssetSet

class AdGroupAssetSetOperation(proto.Message):
    create: AdGroupAssetSet
    remove: str
    def __init__(
        self,
        mapping: Any | None = ...,
        *,
        ignore_unknown_fields: bool = ...,
        create: AdGroupAssetSet = ...,
        remove: str = ...
    ) -> None: ...

class MutateAdGroupAssetSetResult(proto.Message):
    resource_name: str
    ad_group_asset_set: AdGroupAssetSet
    def __init__(
        self,
        mapping: Any | None = ...,
        *,
        ignore_unknown_fields: bool = ...,
        resource_name: str = ...,
        ad_group_asset_set: AdGroupAssetSet = ...
    ) -> None: ...

class MutateAdGroupAssetSetsRequest(proto.Message):
    customer_id: str
    operations: MutableSequence[AdGroupAssetSetOperation]
    partial_failure: bool
    validate_only: bool
    response_content_type: ResponseContentTypeEnum.ResponseContentType
    def __init__(
        self,
        mapping: Any | None = ...,
        *,
        ignore_unknown_fields: bool = ...,
        customer_id: str = ...,
        operations: MutableSequence[AdGroupAssetSetOperation] = ...,
        partial_failure: bool = ...,
        validate_only: bool = ...,
        response_content_type: ResponseContentTypeEnum.ResponseContentType = ...
    ) -> None: ...

class MutateAdGroupAssetSetsResponse(proto.Message):
    results: MutableSequence[MutateAdGroupAssetSetResult]
    partial_failure_error: Status
    def __init__(
        self,
        mapping: Any | None = ...,
        *,
        ignore_unknown_fields: bool = ...,
        results: MutableSequence[MutateAdGroupAssetSetResult] = ...,
        partial_failure_error: Status = ...
    ) -> None: ...
